gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes | Related Functions

# Gtk::TextIter Class Reference
TextView Classes

Typefed as Gtk::TextBuffer::iterator. More...

List of all members.

## Public Types
typedef std::bidirectional_iterator_tag | iterator_category
typedef gunichar | value_type
typedef int | difference_type
typedef value_type | reference
typedef void | pointer
## Public Member Functions
| TextIter ()
| TextIter (const GtkTextIter* gobject)
GtkTextIter* | gobj ()
| Provides access to the underlying C instance.
const GtkTextIter* | gobj () const
| Provides access to the underlying C instance.
TextIter& | operator++ ()
| Alias for forward_char().
const TextIter | operator++ (int)
TextIter& | operator-- ()
| Alias for backward_char().
const TextIter | operator-- (int)
value_type | operator* () const
| Alias for get_char().
| operator bool () const
| Alias for !is_end().
Glib::RefPtr< TextBuffer > | get_buffer () const
| Returns the Gtk::TextBuffer this iterator is associated with.
int | get_offset () const
| Returns the character offset of an iterator.
int | get_line () const
| Returns the line number containing the iterator.
int | get_line_offset () const
| Returns the character offset of the iterator, counting from the start of a newline-terminated line.
int | get_line_index () const
| Returns the byte index of the iterator, counting from the start of a newline-terminated line.
int | get_visible_line_offset () const
| Returns the offset in characters from the start of the line to the given iter, not counting characters that are invisible due to tags with the "invisible" flag toggled on.
int | get_visible_line_index () const
| Returns the number of bytes from the start of the line to the given iter, not counting bytes that are invisible due to tags with the "invisible" flag toggled on.
gunichar | get_char () const
| Returns the Unicode character at this iterator.
Glib::ustring | get_slice (const TextIter&end) const
| Returns the text in the given range.
Glib::ustring | get_text (const TextIter&end) const
| Returns text in the given range.
Glib::ustring | get_visible_slice (const TextIter&end) const
| Like get_slice(), but invisible text is not included.
Glib::ustring | get_visible_text (const TextIter&end) const
| Like get_text(), but invisible text is not included.
Glib::RefPtr< Gdk::Pixbuf > | get_pixbuf () const
| If the element at iter is a pixbuf, the pixbuf is returned (with no new reference count added).
Glib::SListHandle < Glib::RefPtr< TextMark > > | get_marks ()
| Returns a list of all Gtk::TextMark at this location.
Glib::SListHandle < Glib::RefPtr< const TextMark > > | get_marks () const
| Returns a list of all Gtk::TextMark at this location.
Glib::RefPtr< TextChildAnchor > | get_child_anchor ()
| If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).
Glib::RefPtr< const TextChildAnchor > | get_child_anchor () const
| If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).
Glib::SListHandle < Glib::RefPtr< TextTag > > | get_toggled_tags (bool toggled_on=true)
| Returns a list of Gtk::TextTag that are toggled on or off at this point.
Glib::SListHandle < Glib::RefPtr< const TextTag > > | get_toggled_tags (bool toggled_on=true) const
| Returns a list of Gtk::TextTag that are toggled on or off at this point.
bool | begins_tag (const Glib::RefPtr< const TextTag >& tag) const
| Returns `true` if tag is toggled on at exactly this point.
bool | begins_tag () const
bool | ends_tag (const Glib::RefPtr< const TextTag >& tag) const
| Returns `true` if tag is toggled off at exactly this point.
bool | ends_tag () const
bool | toggles_tag (const Glib::RefPtr< const TextTag >& tag) const
| This is equivalent to (begins_tag() || ends_tag()), i.e. it tells you whether a range with tag applied to it begins or ends at iter.
bool | toggles_tag () const
bool | has_tag (const Glib::RefPtr< const TextTag >& tag) const
| Returns `true` if iter is within a range tagged with tag.
bool | has_tag () const
Glib::SListHandle < Glib::RefPtr< TextTag > > | get_tags ()
| Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).
Glib::SListHandle < Glib::RefPtr< const TextTag > > | get_tags () const
| Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).
bool | editable (bool default_setting=true) const
| Returns whether the character at iter is within an editable region of text.
bool | can_insert (bool default_editability=true) const
| Considering the default editability of the buffer, and tags that affect editability, determines whether text inserted at iter would be editable.
bool | starts_word () const
| Determines whether iter begins a natural-language word.
bool | ends_word () const
| Determines whether iter ends a natural-language word.
bool | inside_word () const
| Determines whether iter is inside a natural-language word (as opposed to say inside some whitespace).
bool | starts_sentence () const
| Determines whether iter begins a sentence.
bool | ends_sentence () const
| Determines whether iter ends a sentence.
bool | inside_sentence () const
| Determines whether iter is inside a sentence (as opposed to in between two sentences, e.g. after a period and before the first letter of the next sentence).
bool | starts_line () const
| Returns `true` if iter begins a paragraph, i.e. if get_line_offset() would return 0.
bool | ends_line () const
| Returns `true` if iter points to the start of the paragraph delimiter characters for a line (delimiters will be either a newline, a carriage return, a carriage return followed by a newline, or a Unicode paragraph separator character).
bool | is_cursor_position () const
| See forward_cursor_position() or Pango::LogAttr or pango_break() for details on what a cursor position is.
int | get_chars_in_line () const
| Returns the number of characters in the line containing iter, including the paragraph delimiters.
int | get_bytes_in_line () const
| Returns the number of bytes in the line containing iter, including the paragraph delimiters.
bool | get_attributes (TextAttributes& values) const
Pango::Language | get_language () const
| A convenience wrapper around get_attributes(), which returns the language in effect at iter.
bool | is_end () const
| Returns `true` if iter is the end iterator, i.e. one past the last dereferenceable iterator in the buffer.
bool | is_start () const
| Returns `true` if iter is the first iterator in the buffer, that is if iter has a character offset of 0.
bool | forward_char ()
| Moves iter forward by one character offset.
bool | backward_char ()
| Moves backward by one character offset.
bool | forward_chars (int count)
| Moves count characters if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | backward_chars (int count)
| Moves count characters backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | forward_line ()
| Moves iter to the start of the next line.
bool | backward_line ()
| Moves iter to the start of the previous line.
bool | forward_lines (int count)
| Moves count lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | backward_lines (int count)
| Moves count lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | forward_word_end ()
| Moves forward to the next word end.
bool | backward_word_start ()
| Moves backward to the previous word start.
bool | forward_word_ends (int count)
| Calls forward_word_end() up to count times.
bool | backward_word_starts (int count)
| Calls backward_word_start() up to count times.
bool | forward_visible_line ()
| Moves iter to the start of the next visible line.
bool | backward_visible_line ()
| Moves iter to the start of the previous visible line.
bool | forward_visible_line (int count)
| Moves count visible lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | backward_visible_lines (int count)
| Moves count visible lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | forward_visible_word_end ()
| Moves forward to the next visible word end.
bool | backward_visible_word_start ()
| Moves backward to the previous visible word start.
bool | forward_visible_word_ends (int count)
| Calls forward_visible_word_end() up to count times.
bool | backward_visible_word_starts (int count)
| Calls backward_visible_word_start() up to count times.
bool | forward_sentence_end ()
| Moves forward to the next sentence end.
bool | backward_sentence_start ()
| Moves backward to the previous sentence start; if iter is already at the start of a sentence, moves backward to the next one.
bool | forward_sentence_ends (int count)
| Calls forward_sentence_end() count times (or until forward_sentence_end() returns `false`).
bool | backward_sentence_starts (int count)
| Calls backward_sentence_start() up to count times, or until it returns `false`.
bool | forward_cursor_position ()
| Moves iter forward by a single cursor position.
bool | backward_cursor_position ()
| Like forward_cursor_position(), but moves backward.
bool | forward_cursor_positions (int count)
| Moves up to count cursor positions.
bool | backward_cursor_positions (int count)
| Moves up to count cursor positions.
bool | forward_visible_cursor_position ()
| Moves iter forward to the next visible cursor position.
bool | backward_visible_cursor_position ()
| Moves iter forward to the previous visible cursor position.
bool | forward_visible_cursor_positions (int count)
| Moves up to count visible cursor positions.
bool | backward_visible_cursor_positions (int count)
| Moves up to count visible cursor positions.
void | set_offset (int char_offset)
| Sets iter to point to char_offset.
void | set_line (int line_number)
| Moves iterator iter to the start of the line line_number.
void | set_line_offset (int char_on_line)
| Moves iter within a line, to a new character (not byte) offset.
void | set_line_index (int byte_on_line)
| Same as set_line_offset(), but works with a byte index.
void | forward_to_end ()
| Moves iter forward to the "end iterator," which points one past the last valid character in the buffer.
bool | forward_to_line_end ()
| Moves the iterator to point to the paragraph delimiter characters, which will be either a newline, a carriage return, a carriage return/newline in sequence, or the Unicode paragraph separator character.
void | set_visible_line_offset (int char_on_line)
| Like set_line_offset(), but the offset is in visible characters, i.e. text with a tag making it invisible is not counted in the offset.
void | set_visible_line_index (int byte_on_line)
| Like set_line_index(), but the index is in visible bytes, i.e. text with a tag making it invisible is not counted in the index.
bool | forward_to_tag_toggle (const Glib::RefPtr< TextTag >& tag)
| Moves forward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.
bool | backward_to_tag_toggle (const Glib::RefPtr< TextTag >& tag)
| Moves backward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.
template<class Predicate >
bool | forward_find_char (const Predicate& predicate, const TextIter& limit)
template<class Predicate >
bool | forward_find_char (const Predicate& predicate)
template<class Predicate >
bool | backward_find_char (const Predicate& predicate, const TextIter& limit)
template<class Predicate >
bool | backward_find_char (const Predicate& predicate)
bool | forward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end, const TextIter& limit) const
| Searches forward for str.
bool | forward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end) const
| Same as forward_search(), but searchs to the end.
bool | backward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end, const TextIter& limit) const
| Same as forward_search(), but moves backward.
bool | backward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end) const
| Same as backward_search(), but searches to the start.
int | compare (const TextIter& rhs) const
| A qsort()-style function that returns negative if lhs is less than rhs, positive if lhs is greater than rhs, and 0 if they're equal.
bool | in_range (const TextIter&start, const TextIter&end) const
| Checks whether iter falls in the range [ start, end).
void | order (TextIter& second)
| Swaps the value of first and second if second comes before first in the buffer.
## Protected Attributes
GtkTextIter | gobject_
## Related Functions
(Note that these are not member functions.)
bool | operator== (const TextIter& lhs, const TextIter& rhs)
bool | operator!= (const TextIter& lhs, const TextIter& rhs)
bool | operator< (const TextIter& lhs, const TextIter& rhs)
bool | operator> (const TextIter& lhs, const TextIter& rhs)
bool | operator<= (const TextIter& lhs, const TextIter& rhs)
bool | operator>= (const TextIter& lhs, const TextIter& rhs)
Gtk::TextIter& | wrap (GtkTextIter* object)
const Gtk::TextIter& | wrap (const GtkTextIter* object)

## Detailed Description

Typefed as Gtk::TextBuffer::iterator.

An iterator represents a position between two characters in the text buffer. Iterators are not valid indefinitely; whenever the buffer is modified in a way that affects the number of characters in the buffer, all outstanding iterators become invalid. (Note that deleting 5 characters and then reinserting 5 still invalidates iterators, though you end up with the same number of characters you pass through a state with a different number).

Because of this, iterators can't be used to preserve positions across buffer modifications. To preserve a position, the Gtk::TextBuffer::Mark object is ideal.

You can iterate over characters, words, lines, and sentences, but operator*() and operator++() deal only in characters.

## Member Typedef Documentation

typedef int Gtk::TextIter::difference_type

typedef std::bidirectional_iterator_tag Gtk::TextIter::iterator_category

typedef void Gtk::TextIter::pointer

typedef value_type Gtk::TextIter::reference

typedef gunichar Gtk::TextIter::value_type

## Constructor & Destructor Documentation

Gtk::TextIter::TextIter | ( |  | ) |

Gtk::TextIter::TextIter | ( | const GtkTextIter * | gobject | ) | `[explicit]`

## Member Function Documentation

bool Gtk::TextIter::backward_char | ( |  | ) |

Moves backward by one character offset.

Returns `true` if movement was possible; if iter was the first in the buffer (character offset 0), backward_char() returns `false` for convenience when writing loops.

Returns:
  Whether movement was possible.

bool Gtk::TextIter::backward_chars | ( | int | count | ) |

Moves count characters backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`.

Parameters:

  count | Number of characters to move.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::backward_cursor_position | ( |  | ) |

Like forward_cursor_position(), but moves backward.

Returns:
  `true` if we moved.

bool Gtk::TextIter::backward_cursor_positions | ( | int | count | ) |

Moves up to count cursor positions.

See forward_cursor_position() for details.

Parameters:

  count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable.

template <class Predicate >

bool Gtk::TextIter::backward_find_char | ( | const Predicate & | predicate,
|  | const TextIter& | limit
| ) |  |

template <class Predicate >

bool Gtk::TextIter::backward_find_char | ( | const Predicate & | predicate | ) |

bool Gtk::TextIter::backward_line | ( |  | ) |

Moves iter to the start of the previous line.

Returns `true` if iter could be moved; i.e. if iter was at character offset 0, this function returns `false`. Therefore if iter was already on line 0, but not at the start of the line, iter is snapped to the start of the line and the function returns `true`. (Note that this implies that in a loop calling this function, the line number may not change on every iteration, if your first iteration is on line 0.)

Returns:
  Whether iter moved.

bool Gtk::TextIter::backward_lines | ( | int | count | ) |

Moves count lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves forward by 0 - count lines.

Parameters:

  count | Number of lines to move backward.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::backward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end,
|  | const TextIter& | limit
| ) |  | const

Same as forward_search(), but moves backward.

Parameters:

  str | Search string.
  flags | Bitmask of flags affecting the search.
  match_start | Return location for start of match.
  match_end | Return location for end of match.
  limit | Location of last possible match_start.

Returns:
  Whether a match was found.

bool Gtk::TextIter::backward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end
| ) |  | const

Same as backward_search(), but searches to the start.

Parameters:

  str | Search string.
  flags | Bitmask of flags affecting the search.
  match_start | Return location for start of match, or `0`.
  match_end | Return location for end of match, or `0`.

Returns:
  Whether a match was found.

bool Gtk::TextIter::backward_sentence_start | ( |  | ) |

Moves backward to the previous sentence start; if iter is already at the start of a sentence, moves backward to the next one.

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_sentence_starts | ( | int | count | ) |

Calls backward_sentence_start() up to count times, or until it returns `false`.

If count is negative, moves forward instead of backward.

Parameters:

  count | Number of sentences to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_to_tag_toggle | ( | const Glib::RefPtr< TextTag >& | tag | ) |

Moves backward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.

If no matching tag toggles are found, returns `false`, otherwise `true`. Does not return toggles located at iter, only toggles before iter. Sets iter to the location of the toggle, or the start of the buffer if no toggle is found.

Parameters:

  tag | A Gtk::TextTag, or `0`.

Returns:
  Whether we found a tag toggle before iter.

bool Gtk::TextIter::backward_visible_cursor_position | ( |  | ) |

Moves iter forward to the previous visible cursor position.

See backward_cursor_position() for details.

Since gtkmm 2.4:

Returns:
  `true` if we moved and the new position is dereferenceable.

bool Gtk::TextIter::backward_visible_cursor_positions | ( | int | count | ) |

Moves up to count visible cursor positions.

See backward_cursor_position() for details.

Since gtkmm 2.4:

Parameters:

  count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable.

bool Gtk::TextIter::backward_visible_line | ( |  | ) |

Moves iter to the start of the previous visible line.

Returns `true` if iter could be moved; i.e. if iter was at character offset 0, this function returns `false`. Therefore if iter was already on line 0, but not at the start of the line, iter is snapped to the start of the line and the function returns `true`. (Note that this implies that in a loop calling this function, the line number may not change on every iteration, if your first iteration is on line 0.)

Since gtkmm 2.8:

Returns:
  Whether iter moved.

bool Gtk::TextIter::backward_visible_lines | ( | int | count | ) |

Moves count visible lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves forward by 0 - count lines.

Since gtkmm 2.8:

Parameters:

  count | Number of lines to move backward.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::backward_visible_word_start | ( |  | ) |

Moves backward to the previous visible word start.

(If iter is currently on a word start, moves backward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Since gtkmm 2.4:

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_visible_word_starts | ( | int | count | ) |

Calls backward_visible_word_start() up to count times.

Since gtkmm 2.4:

Parameters:

  count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_word_start | ( |  | ) |

Moves backward to the previous word start.

(If iter is currently on a word start, moves backward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_word_starts | ( | int | count | ) |

Calls backward_word_start() up to count times.

Parameters:

  count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::begins_tag | ( |  | ) | const

bool Gtk::TextIter::begins_tag | ( | const Glib::RefPtr< const TextTag >& | tag | ) | const

Returns `true` if tag is toggled on at exactly this point.

If tag is `0`, returns `true` if any tag is toggled on at this point. Note that the begins_tag() returns `true` if iter is the start of the tagged range; has_tag() tells you whether an iterator is within a tagged range.

Parameters:

  tag | A Gtk::TextTag, or `0`.

Returns:
  Whether iter is the start of a range tagged with tag.

bool Gtk::TextIter::can_insert | ( | bool | default_editability = `true` | ) | const

Considering the default editability of the buffer, and tags that affect editability, determines whether text inserted at iter would be editable.

If text inserted at iter would be editable then the user should be allowed to insert text at iter. Gtk::TextBuffer::insert_interactive() uses this function to decide whether insertions are allowed at a given position.

Parameters:

  default_editability | `true` if text is editable by default.

Returns:
  Whether text inserted at iter would be editable.

int Gtk::TextIter::compare | ( | const TextIter& | rhs | ) | const

A qsort()-style function that returns negative if lhs is less than rhs, positive if lhs is greater than rhs, and 0 if they're equal.

Ordering is in character offset order, i.e. the first character in the buffer is less than the second character in the buffer.

Parameters:

  rhs | Another Gtk::TextIter.

Returns:
  -1 if lhs is less than rhs, 1 if lhs is greater, 0 if they are equal.

bool Gtk::TextIter::editable | ( | bool | default_setting = `true` | ) | const

Returns whether the character at iter is within an editable region of text.

Non-editable text is "locked" and can't be changed by the user via Gtk::TextView. This function is simply a convenience wrapper around get_attributes(). If no tags applied to this text affect editability, default_setting will be returned.

You don't want to use this function to decide whether text can be inserted at iter, because for insertion you don't want to know whether the char at iter is inside an editable range, you want to know whether a new character inserted at iter would be inside an editable range. Use can_insert() to handle this case.

Parameters:

  default_setting | `true` if text is editable by default.

Returns:
  Whether iter is inside an editable range.

bool Gtk::TextIter::ends_line | ( |  | ) | const

Returns `true` if iter points to the start of the paragraph delimiter characters for a line (delimiters will be either a newline, a carriage return, a carriage return followed by a newline, or a Unicode paragraph separator character).

Note that an iterator pointing to the `\n` of a `\r``\n` pair will not be counted as the end of a line, the line ends before the `\r`. The end iterator is considered to be at the end of a line, even though there are no paragraph delimiter chars there.

Returns:
  Whether iter is at the end of a line.

bool Gtk::TextIter::ends_sentence | ( |  | ) | const

Determines whether iter ends a sentence.

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter is at the end of a sentence.

bool Gtk::TextIter::ends_tag | ( | const Glib::RefPtr< const TextTag >& | tag | ) | const

Returns `true` if tag is toggled off at exactly this point.

If tag is `0`, returns `true` if any tag is toggled off at this point. Note that the ends_tag() returns `true` if iter is the end of the tagged range; has_tag() tells you whether an iterator is within a tagged range.

Parameters:

  tag | A Gtk::TextTag, or `0`.

Returns:
  Whether iter is the end of a range tagged with tag.

bool Gtk::TextIter::ends_tag | ( |  | ) | const

bool Gtk::TextIter::ends_word | ( |  | ) | const

Determines whether iter ends a natural-language word.

Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter is at the end of a word.

bool Gtk::TextIter::forward_char | ( |  | ) |

Moves iter forward by one character offset.

Note that images embedded in the buffer occupy 1 character slot, so forward_char() may actually move onto an image instead of a character, if you have images in your buffer. If iter is the end iterator or one character before it, iter will now point at the end iterator, and forward_char() returns `false` for convenience when writing loops.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::forward_chars | ( | int | count | ) |

Moves count characters if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the new position of iter is different from its original position, and dereferenceable (the last iterator in the buffer is not dereferenceable). If count is 0, the function does nothing and returns `false`.

Parameters:

  count | Number of characters to move, may be negative.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::forward_cursor_position | ( |  | ) |

Moves iter forward by a single cursor position.

Cursor positions are (unsurprisingly) positions where the cursor can appear. Perhaps surprisingly, there may not be a cursor position between all characters. The most common example for European languages would be a carriage return/newline sequence. For some Unicode characters, the equivalent of say the letter "a" with an accent mark will be represented as two characters, first the letter then a "combining mark" that causes the accent to be rendered; so the cursor can't go between those two characters. See also the Pango::LogAttr structure and pango_break() function.

Returns:
  `true` if we moved and the new position is dereferenceable.

bool Gtk::TextIter::forward_cursor_positions | ( | int | count | ) |

Moves up to count cursor positions.

See forward_cursor_position() for details.

Parameters:

  count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable.

template <class Predicate >

bool Gtk::TextIter::forward_find_char | ( | const Predicate & | predicate,
|  | const TextIter& | limit
| ) |  |

template <class Predicate >

bool Gtk::TextIter::forward_find_char | ( | const Predicate & | predicate | ) |

bool Gtk::TextIter::forward_line | ( |  | ) |

Moves iter to the start of the next line.

If the iter is already on the last line of the buffer, moves the iter to the end of the current line. If after the operation, the iter is at the end of the buffer and not dereferencable, returns `false`. Otherwise, returns `true`.

Returns:
  Whether iter can be dereferenced.

bool Gtk::TextIter::forward_lines | ( | int | count | ) |

Moves count lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves backward by 0 - count lines.

Parameters:

  count | Number of lines to move forward.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::forward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end,
|  | const TextIter& | limit
| ) |  | const

Searches forward for str.

Any match is returned by setting match_start to the first character of the match and match_end to the first character after the match. The search will not continue past limit. Note that a search is a linear or O(n) operation, so you may wish to use limit to avoid locking up your UI on large buffers.

If the Gtk::TEXT_SEARCH_VISIBLE_ONLY flag is present, the match may have invisible text interspersed in str. i.e. str will be a possibly-noncontiguous subsequence of the matched range. similarly, if you specify Gtk::TEXT_SEARCH_TEXT_ONLY, the match may have pixbufs or child widgets mixed inside the matched range. If these flags are not given, the match must be exact; the special 0xFFFC character in str will match embedded pixbufs or child widgets.

Parameters:

  str | A search string.
  flags | Flags affecting how the search is done.
  match_start | Return location for start of match.
  match_end | Return location for end of match.
  limit | Bound for the search.

Returns:
  Whether a match was found.

bool Gtk::TextIter::forward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end
| ) |  | const

Same as forward_search(), but searchs to the end.

Parameters:

  str | A search string.
  flags | Flags affecting how the search is done.
  match_start | Return location for start of match, or `0`.
  match_end | Return location for end of match, or `0`.

Returns:
  Whether a match was found.

bool Gtk::TextIter::forward_sentence_end | ( |  | ) |

Moves forward to the next sentence end.

(If iter is at the end of a sentence, moves to the next end of sentence.) Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::forward_sentence_ends | ( | int | count | ) |

Calls forward_sentence_end() count times (or until forward_sentence_end() returns `false`).

If count is negative, moves backward instead of forward.

Parameters:

  count | Number of sentences to move.

Returns:
  `true` if iter moved and is not the end iterator.

void Gtk::TextIter::forward_to_end | ( |  | ) |

Moves iter forward to the "end iterator," which points one past the last valid character in the buffer.

get_char() called on the end iterator returns 0, which is convenient for writing loops.

bool Gtk::TextIter::forward_to_line_end | ( |  | ) |

Moves the iterator to point to the paragraph delimiter characters, which will be either a newline, a carriage return, a carriage return/newline in sequence, or the Unicode paragraph separator character.

If the iterator is already at the paragraph delimiter characters, moves to the paragraph delimiter characters for the next line. If iter is on the last line in the buffer, which does not end in paragraph delimiters, moves to the end iterator (end of the last line), and returns `false`.

Returns:
  `true` if we moved and the new location is not the end iterator.

bool Gtk::TextIter::forward_to_tag_toggle | ( | const Glib::RefPtr< TextTag >& | tag | ) |

Moves forward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.

If no matching tag toggles are found, returns `false`, otherwise `true`. Does not return toggles located at iter, only toggles after iter. Sets iter to the location of the toggle, or to the end of the buffer if no toggle is found.

Parameters:

  tag | A Gtk::TextTag, or `0`.

Returns:
  Whether we found a tag toggle after iter.

bool Gtk::TextIter::forward_visible_cursor_position | ( |  | ) |

Moves iter forward to the next visible cursor position.

See forward_cursor_position() for details.

Since gtkmm 2.4:

Returns:
  `true` if we moved and the new position is dereferenceable.

bool Gtk::TextIter::forward_visible_cursor_positions | ( | int | count | ) |

Moves up to count visible cursor positions.

See forward_cursor_position() for details.

Since gtkmm 2.4:

Parameters:

  count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable.

bool Gtk::TextIter::forward_visible_line | ( |  | ) |

Moves iter to the start of the next visible line.

Returns `true` if there was a next line to move to, and `false` if iter was simply moved to the end of the buffer and is now not dereferenceable, or if iter was already at the end of the buffer.

Since gtkmm 2.8:

Returns:
  Whether iter can be dereferenced.

bool Gtk::TextIter::forward_visible_line | ( | int | count | ) |

Moves count visible lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves backward by 0 - count lines.

Since gtkmm 2.8:

Parameters:

  count | Number of lines to move forward.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::forward_visible_word_end | ( |  | ) |

Moves forward to the next visible word end.

(If iter is currently on a word end, moves forward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Since gtkmm 2.4:

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::forward_visible_word_ends | ( | int | count | ) |

Calls forward_visible_word_end() up to count times.

Since gtkmm 2.4:

Parameters:

  count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::forward_word_end | ( |  | ) |

Moves forward to the next word end.

(If iter is currently on a word end, moves forward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::forward_word_ends | ( | int | count | ) |

Calls forward_word_end() up to count times.

Parameters:

  count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::get_attributes | ( | TextAttributes& | values | ) | const

Glib::RefPtr<TextBuffer> Gtk::TextIter::get_buffer | ( |  | ) | const

Returns the Gtk::TextBuffer this iterator is associated with.

Returns:
  The buffer.

int Gtk::TextIter::get_bytes_in_line | ( |  | ) | const

Returns the number of bytes in the line containing iter, including the paragraph delimiters.

Returns:
  Number of bytes in the line.

gunichar Gtk::TextIter::get_char | ( |  | ) | const

Returns the Unicode character at this iterator.

(Equivalent to operator* on a C++ iterator.) If the element at this iterator is a non-character element, such as an image embedded in the buffer, the Unicode "unknown" character 0xFFFC is returned. If invoked on the end iterator, zero is returned; zero is not a valid Unicode character. So you can write a loop which ends when get_char() returns 0.

Returns:
  A Unicode character, or 0 if iter is not dereferenceable.

int Gtk::TextIter::get_chars_in_line | ( |  | ) | const

Returns the number of characters in the line containing iter, including the paragraph delimiters.

Returns:
  Number of characters in the line.

Glib::RefPtr<TextChildAnchor> Gtk::TextIter::get_child_anchor | ( |  | ) |

If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).

Otherwise, `0` is returned.

Returns:
  The anchor at iter.

Glib::RefPtr<const TextChildAnchor> Gtk::TextIter::get_child_anchor | ( |  | ) | const

If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).

Otherwise, `0` is returned.

Returns:
  The anchor at iter.

Pango::Language Gtk::TextIter::get_language | ( |  | ) | const

A convenience wrapper around get_attributes(), which returns the language in effect at iter.

If no tags affecting language apply to iter, the return value is identical to that of gtk_get_default_language().

Returns:
  Language in effect at iter.

int Gtk::TextIter::get_line | ( |  | ) | const

Returns the line number containing the iterator.

Lines in a Gtk::TextBuffer are numbered beginning with 0 for the first line in the buffer.

Returns:
  A line number.

int Gtk::TextIter::get_line_index | ( |  | ) | const

Returns the byte index of the iterator, counting from the start of a newline-terminated line.

Remember that Gtk::TextBuffer encodes text in UTF-8, and that characters can require a variable number of bytes to represent.

Returns:
  Distance from start of line, in bytes.

int Gtk::TextIter::get_line_offset | ( |  | ) | const

Returns the character offset of the iterator, counting from the start of a newline-terminated line.

The first character on the line has offset 0.

Returns:
  Offset from start of line.

Glib::SListHandle< Glib::RefPtr<TextMark> > Gtk::TextIter::get_marks | ( |  | ) |

Returns a list of all Gtk::TextMark at this location.

Because marks are not iterable (they don't take up any "space" in the buffer, they are just marks in between iterable locations), multiple marks can exist in the same place. The returned list is not in any meaningful order.

Returns:
  List of Gtk::TextMark.

Glib::SListHandle< Glib::RefPtr<const TextMark> > Gtk::TextIter::get_marks | ( |  | ) | const

Returns a list of all Gtk::TextMark at this location.

Because marks are not iterable (they don't take up any "space" in the buffer, they are just marks in between iterable locations), multiple marks can exist in the same place. The returned list is not in any meaningful order.

Returns:
  List of Gtk::TextMark.

int Gtk::TextIter::get_offset | ( |  | ) | const

Returns the character offset of an iterator.

Each character in a Gtk::TextBuffer has an offset, starting with 0 for the first character in the buffer. Use Gtk::TextBuffer::get_iter_at_offset() to convert an offset back into an iterator.

Returns:
  A character offset.

Glib::RefPtr<Gdk::Pixbuf> Gtk::TextIter::get_pixbuf | ( |  | ) | const

If the element at iter is a pixbuf, the pixbuf is returned (with no new reference count added).

Otherwise, `0` is returned.

Returns:
  The pixbuf at iter.

Glib::ustring Gtk::TextIter::get_slice | ( | const TextIter& | end | ) | const

Returns the text in the given range.

A "slice" is an array of characters encoded in UTF-8 format, including the Unicode "unknown" character 0xFFFC for iterable non-character elements in the buffer, such as images. Because images are encoded in the slice, byte and character offsets in the returned array will correspond to byte offsets in the text buffer. Note that 0xFFFC can occur in normal text as well, so it is not a reliable indicator that a pixbuf or widget is in the buffer.

Parameters:

  end | Iterator at end of a range.

Returns:
  Slice of text from the buffer.

Glib::SListHandle< Glib::RefPtr<const TextTag> > Gtk::TextIter::get_tags | ( |  | ) | const

Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).

Returns:
  List of Gtk::TextTag.

Glib::SListHandle< Glib::RefPtr<TextTag> > Gtk::TextIter::get_tags | ( |  | ) |

Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).

Returns:
  List of Gtk::TextTag.

Glib::ustring Gtk::TextIter::get_text | ( | const TextIter& | end | ) | const

Returns text in the given range.

If the range contains non-text elements such as images, the character and byte offsets in the returned string will not correspond to character and byte offsets in the buffer. If you want offsets to correspond, see get_slice().

Parameters:

  end | Iterator at end of a range.

Returns:
  Array of characters from the buffer.

Glib::SListHandle< Glib::RefPtr<TextTag> > Gtk::TextIter::get_toggled_tags | ( | bool | toggled_on = `true` | ) |

Returns a list of Gtk::TextTag that are toggled on or off at this point.

(If toggled_on is `true`, the list contains tags that are toggled on.) If a tag is toggled on at iter, then some non-empty range of characters following iter has that tag applied to it. If a tag is toggled off, then some non-empty range following iter does not have the tag applied to it.

Parameters:

  toggled_on | `true` to get toggled-on tags.

Returns:
  Tags toggled at this point.

Glib::SListHandle< Glib::RefPtr<const TextTag> > Gtk::TextIter::get_toggled_tags | ( | bool | toggled_on = `true` | ) | const

Returns a list of Gtk::TextTag that are toggled on or off at this point.

(If toggled_on is `true`, the list contains tags that are toggled on.) If a tag is toggled on at iter, then some non-empty range of characters following iter has that tag applied to it. If a tag is toggled off, then some non-empty range following iter does not have the tag applied to it.

Parameters:

  toggled_on | `true` to get toggled-on tags.

Returns:
  Tags toggled at this point.

int Gtk::TextIter::get_visible_line_index | ( |  | ) | const

Returns the number of bytes from the start of the line to the given iter, not counting bytes that are invisible due to tags with the "invisible" flag toggled on.

Returns:
  Byte index of iter with respect to the start of the line.

int Gtk::TextIter::get_visible_line_offset | ( |  | ) | const

Returns the offset in characters from the start of the line to the given iter, not counting characters that are invisible due to tags with the "invisible" flag toggled on.

Returns:
  Offset in visible characters from the start of the line.

Glib::ustring Gtk::TextIter::get_visible_slice | ( | const TextIter& | end | ) | const

Like get_slice(), but invisible text is not included.

Invisible text is usually invisible because a Gtk::TextTag with the "invisible" attribute turned on has been applied to it.

Parameters:

  end | Iterator at end of range.

Returns:
  Slice of text from the buffer.

Glib::ustring Gtk::TextIter::get_visible_text | ( | const TextIter& | end | ) | const

Like get_text(), but invisible text is not included.

Invisible text is usually invisible because a Gtk::TextTag with the "invisible" attribute turned on has been applied to it.

Parameters:

  end | Iterator at end of range.

Returns:
  String containing visible text in the range.

const GtkTextIter* Gtk::TextIter::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C instance.

GtkTextIter* Gtk::TextIter::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C instance.

bool Gtk::TextIter::has_tag | ( |  | ) | const

bool Gtk::TextIter::has_tag | ( | const Glib::RefPtr< const TextTag >& | tag | ) | const

Returns `true` if iter is within a range tagged with tag.

Parameters:

  tag | A Gtk::TextTag.

Returns:
  Whether iter is tagged with tag.

bool Gtk::TextIter::in_range | ( | const TextIter& | start,
|  | const TextIter& | end
| ) |  | const

Checks whether iter falls in the range [ start, end).

start and end must be in ascending order.

Parameters:

  start | Start of range.
  end | End of range.

Returns:
  `true` if iter is in the range.

bool Gtk::TextIter::inside_sentence | ( |  | ) | const

Determines whether iter is inside a sentence (as opposed to in between two sentences, e.g. after a period and before the first letter of the next sentence).

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter is inside a sentence.

bool Gtk::TextIter::inside_word | ( |  | ) | const

Determines whether iter is inside a natural-language word (as opposed to say inside some whitespace).

Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter is inside a word.

bool Gtk::TextIter::is_cursor_position | ( |  | ) | const

See forward_cursor_position() or Pango::LogAttr or pango_break() for details on what a cursor position is.

Returns:
  `true` if the cursor can be placed at iter.

bool Gtk::TextIter::is_end | ( |  | ) | const

Returns `true` if iter is the end iterator, i.e. one past the last dereferenceable iterator in the buffer.

is_end() is the most efficient way to check whether an iterator is the end iterator.

Returns:
  Whether iter is the end iterator.

bool Gtk::TextIter::is_start | ( |  | ) | const

Returns `true` if iter is the first iterator in the buffer, that is if iter has a character offset of 0.

Returns:
  Whether iter is the first in the buffer.

Gtk::TextIter::operator bool | ( |  | ) | const`[inline]`

Alias for !is_end().

value_type Gtk::TextIter::operator* | ( |  | ) | const`[inline]`

Alias for get_char().

TextIter& Gtk::TextIter::operator++ | ( |  | ) | `[inline]`

Alias for forward_char().

const TextIter Gtk::TextIter::operator++ | ( | int |  | ) | `[inline]`

const TextIter Gtk::TextIter::operator-- | ( | int |  | ) | `[inline]`

TextIter& Gtk::TextIter::operator-- | ( |  | ) | `[inline]`

Alias for backward_char().

void Gtk::TextIter::order | ( | TextIter& | second | ) |

Swaps the value of first and second if second comes before first in the buffer.

That is, ensures that first and second are in sequence. Most text buffer functions that take a range call this automatically on your behalf, so there's no real reason to call it yourself in those cases. There are some exceptions, such as in_range(), that expect a pre-sorted range.

Parameters:

  second | Another Gtk::TextIter.

void Gtk::TextIter::set_line | ( | int | line_number | ) |

Moves iterator iter to the start of the line line_number.

If line_number is negative or larger than the number of lines in the buffer, moves iter to the start of the last line in the buffer.

Parameters:

  line_number | Line number (counted from 0).

void Gtk::TextIter::set_line_index | ( | int | byte_on_line | ) |

Same as set_line_offset(), but works with a byte index.

The given byte index must be at the start of a character, it can't be in the middle of a UTF-8 encoded character.

Parameters:

  byte_on_line | A byte index relative to the start of iter's current line.

void Gtk::TextIter::set_line_offset | ( | int | char_on_line | ) |

Moves iter within a line, to a new character (not byte) offset.

The given character offset must be less than or equal to the number of characters in the line; if equal, iter moves to the start of the next line. See set_line_index() if you have a byte index rather than a character offset.

Parameters:

  char_on_line | A character offset relative to the start of iter's current line.

void Gtk::TextIter::set_offset | ( | int | char_offset | ) |

Sets iter to point to char_offset.

char_offset counts from the start of the entire text buffer, starting with 0.

Parameters:

  char_offset | A character number.

void Gtk::TextIter::set_visible_line_index | ( | int | byte_on_line | ) |

Like set_line_index(), but the index is in visible bytes, i.e. text with a tag making it invisible is not counted in the index.

Parameters:

  byte_on_line | A byte index.

void Gtk::TextIter::set_visible_line_offset | ( | int | char_on_line | ) |

Like set_line_offset(), but the offset is in visible characters, i.e. text with a tag making it invisible is not counted in the offset.

Parameters:

  char_on_line | A character offset.

bool Gtk::TextIter::starts_line | ( |  | ) | const

Returns `true` if iter begins a paragraph, i.e. if get_line_offset() would return 0.

However this function is potentially more efficient than get_line_offset() because it doesn't have to compute the offset, it just has to see whether it's 0.

Returns:
  Whether iter begins a line.

bool Gtk::TextIter::starts_sentence | ( |  | ) | const

Determines whether iter begins a sentence.

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter is at the start of a sentence.

bool Gtk::TextIter::starts_word | ( |  | ) | const

Determines whether iter begins a natural-language word.

Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter is at the start of a word.

bool Gtk::TextIter::toggles_tag | ( |  | ) | const

bool Gtk::TextIter::toggles_tag | ( | const Glib::RefPtr< const TextTag >& | tag | ) | const

This is equivalent to (begins_tag() || ends_tag()), i.e. it tells you whether a range with tag applied to it begins or ends at iter.

Parameters:

  tag | A Gtk::TextTag, or `0`.

Returns:
  Whether tag is toggled on or off at iter.

## Friends And Related Function Documentation

bool operator!= | ( | const TextIter& | lhs,
|  | const TextIter& | rhs
| ) |  | `[related]`

Parameters:

  lhs | The left-hand side
  rhs | The right-hand side

Returns:
  The result

bool operator< | ( | const TextIter& | lhs,
|  | const TextIter& | rhs
| ) |  | `[related]`

Parameters:

  lhs | The left-hand side
  rhs | The right-hand side

Returns:
  The result

bool operator<= | ( | const TextIter& | lhs,
|  | const TextIter& | rhs
| ) |  | `[related]`

Parameters:

  lhs | The left-hand side
  rhs | The right-hand side

Returns:
  The result

bool operator== | ( | const TextIter& | lhs,
|  | const TextIter& | rhs
| ) |  | `[related]`

Parameters:

  lhs | The left-hand side
  rhs | The right-hand side

Returns:
  The result

bool operator> | ( | const TextIter& | lhs,
|  | const TextIter& | rhs
| ) |  | `[related]`

Parameters:

  lhs | The left-hand side
  rhs | The right-hand side

Returns:
  The result

bool operator>= | ( | const TextIter& | lhs,
|  | const TextIter& | rhs
| ) |  | `[related]`

Parameters:

  lhs | The left-hand side
  rhs | The right-hand side

Returns:
  The result

const Gtk::TextIter& wrap | ( | const GtkTextIter * | object | ) | `[related]`

Parameters:

  object | The C instance

Returns:
  A C++ instance that wraps this C instance.

Gtk::TextIter& wrap | ( | GtkTextIter * | object | ) | `[related]`

Parameters:

  object | The C instance

Returns:
  A C++ instance that wraps this C instance.

## Member Data Documentation

GtkTextIter Gtk::TextIter::gobject_`[protected]`

The documentation for this class was generated from the following file:

- gtkmm/textiter.h